Fork me on GitHub

[leetcode-494-Target Sum]

You are given a list of non-negative integers, a1, a2, ..., an, and a target, S. Now you have 2 symbols + and -. For each integer, you should choose one from + and - as its new symbol.

Find out how many ways to assign symbols to make sum of integers equal to target S.

Example 1:

Input: nums is [1, 1, 1, 1, 1], S is 3. 
Output: 5
Explanation: 

-1+1+1+1+1 = 3
+1-1+1+1+1 = 3
+1+1-1+1+1 = 3
+1+1+1-1+1 = 3
+1+1+1+1-1 = 3

There are 5 ways to assign symbols to make the sum of nums be target 3.

 

Note:

  1. The length of the given array is positive and will not exceed 20.
  2. The sum of elements in the given array will not exceed 1000.
  3. Your output answer is guaranteed to be fitted in a 32-bit integer.

思路:

分析:深度优先搜索,尝试每次添加+或者-,

当当前cnt为nums数组的大小的时候,判断sum与S是否相等,

如果相等就result++。sum为当前cnt步数情况下的前面所有部分的总和。

参考:

https://www.liuchuo.net/archives/3098

int result;
     int findTargetSumWays(vector<int>& nums, int S) {
         dfs(0, 0, nums, S);
         return result;
     }
     void dfs(int sum, int cnt, vector<int>& nums, int S) {
         if (cnt == nums.size()) {
             if (sum == S)
                 result++;
             return;
         }
         dfs(sum + nums[cnt], cnt + 1, nums, S);
         dfs(sum - nums[cnt], cnt + 1, nums, S);
     }

如下是动态规划版本介绍,参考:https://discuss.leetcode.com/topic/76243/java-15-ms-c-3-ms-o-ns-iterative-dp-solution-using-subset-sum-with-explanation 

The recursive solution is very slow, because its runtime is exponential

The original problem statement is equivalent to:
Find a subset of nums that need to be positive, and the rest of them negative, such that the sum is equal to target

Let P be the positive subset and N be the negative subset
For example:
Given nums = [1, 2, 3, 4, 5] and target = 3 then one possible solution is +1-2+3-4+5 = 3
Here positive subset is P = [1, 3, 5] and negative subset is N = [2, 4]

Then let's see how this can be converted to a subset sum problem:

                  sum(P) - sum(N) = target
sum(P) + sum(N) + sum(P) - sum(N) = target + sum(P) + sum(N)
                       2 * sum(P) = target + sum(nums)

So the original problem has been converted to a subset sum problem as follows:
Find a subset P of nums such that sum(P) = (target + sum(nums)) / 2

Note that the above formula has proved that target + sum(nums) must be even
We can use that fact to quickly identify inputs that do not have a solution (Thanks to @BrunoDeNadaiSarnaglia for the suggestion)
For detailed explanation on how to solve subset sum problem, you may refer to Partition Equal Subset Sum

Here is Java solution (15 ms)

    public int findTargetSumWays(int[] nums, int s) {
        int sum = 0;
        for (int n : nums)
            sum += n;
        return sum < s || (s + sum) % 2 > 0 ? 0 : subsetSum(nums, (s + sum) >>> 1); 
    }   

    public int subsetSum(int[] nums, int s) {
        int[] dp = new int[s + 1]; 
        dp[0] = 1;
        for (int n : nums)
            for (int i = s; i >= n; i--)
                dp[i] += dp[i - n]; 
        return dp[s];
    } 

Here is C++ solution (3 ms)

class Solution {
public:
    int findTargetSumWays(vector<int>& nums, int s) {
        int sum = accumulate(nums.begin(), nums.end(), 0);
        return sum < s || (s + sum) & 1 ? 0 : subsetSum(nums, (s + sum) >> 1); 
    }   

    int subsetSum(vector<int>& nums, int s) {
        int dp[s + 1] = { 0 };
        dp[0] = 1;
        for (int n : nums)
            for (int i = s; i >= n; i--)
                dp[i] += dp[i - n];
        return dp[s];
    }
};

Dynamic Programming方法

参考:https://zhangyuzhu13.github.io/2017/02/13/LeetCode%E4%B9%8B494.%20Target%20Sum%E6%80%9D%E8%B7%AF/

要想到DP方法需要再分析一下题目了,乍一看似乎看不出有求最优解的痕迹。我所熟悉的使用DP场景都是需要求最优解,找最优子结构的。这个问题不明显。但可以往0-1背包问题上想一想,每个数字为正或为负,同时增一倍,则变为了,每个数字不选,或选2倍。这就靠到0-1背包上了。则基数就不再是0,而是nums数组中所有数字之和为基数,在此基础上进行选2倍或不选,目标数字S也相应变为S+Sum。依靠数学公式推论为:设最后选择为正的之和为in,为负的之和为out,则有公式:
in - out = S
in + out = sum
推出:2*in = S + sum
则我们需要的就是把目标改为S+sum,把每个数字改为原来的2倍,从中选择数字,使之和为S+sum。
因此,DP解之。代码如下:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
 
public class Solution {
public int findTargetSumWays(int[] nums, int S) {
int sum = 0;
for(int i = 0;i < nums.length;i++){
sum += nums[i];
nums[i] *= 2;
}
if(sum < S ) return 0;
int target = sum + S;
int[] dp = new int[target+1];
dp[0] = 1;
for(int i = 0;i < nums.length; i++){
for(int j = target;j >= 0;j--){
if(j >= nums[i]){
dp[j] += dp[j-nums[i]];
}
}
}
return dp[target];
}
}

 

然后运行时间就。。到了20ms,击败80%+,DP大法好。。

 
posted @ 2017-06-20 20:44  hellowOOOrld  阅读(257)  评论(0编辑  收藏  举报